"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
function _ui() {
  const data = require("@teambit/ui");
  _ui = function () {
    return data;
  };
  return data;
}
function _react() {
  const data = _interopRequireWildcard(require("react"));
  _react = function () {
    return data;
  };
  return data;
}
function _uuid() {
  const data = require("uuid");
  _uuid = function () {
    return data;
  };
  return data;
}
function _uiFoundationUiNotifications() {
  const data = require("@teambit/ui-foundation.ui.notifications.notification-context");
  _uiFoundationUiNotifications = function () {
    return data;
  };
  return data;
}
function _uiFoundationUiNotifications2() {
  const data = require("@teambit/ui-foundation.ui.notifications.notification-center");
  _uiFoundationUiNotifications2 = function () {
    return data;
  };
  return data;
}
function _uiFoundationUiNotifications3() {
  const data = require("@teambit/ui-foundation.ui.notifications.store");
  _uiFoundationUiNotifications3 = function () {
    return data;
  };
  return data;
}
function _notificationReducer() {
  const data = require("./notification-reducer");
  _notificationReducer = function () {
    return data;
  };
  return data;
}
function _notifications() {
  const data = require("./notifications.aspect");
  _notifications = function () {
    return data;
  };
  return data;
}
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
/**
 * extension
 */
class NotificationUI {
  static async provider([uiRuntimeExtension]) {
    return new NotificationUI(uiRuntimeExtension);
  }
  constructor(uiRuntimeExtension) {
    _defineProperty(this, "dispatch", void 0);
    /** adds a full message to the log */
    _defineProperty(this, "add", (message, level) => {
      const id = (0, _uuid().v1)();
      this.dispatch?.({
        type: 'add',
        content: {
          id,
          message,
          level,
          time: new Date().toISOString()
        }
      });
      return id;
    });
    /** adds a message with level "info" to the log */
    _defineProperty(this, "log", message => this.add(message, _uiFoundationUiNotifications3().MessageLevel.info));
    /** adds a message with level "warning" to the log */
    _defineProperty(this, "warn", message => this.add(message, _uiFoundationUiNotifications3().MessageLevel.warning));
    /** adds a message with level "error" to the log */
    _defineProperty(this, "error", message => this.add(message, _uiFoundationUiNotifications3().MessageLevel.error));
    /** adds a message with level "success" to the log */
    _defineProperty(this, "success", message => this.add(message, _uiFoundationUiNotifications3().MessageLevel.success));
    /** removes all notifications */
    _defineProperty(this, "clear", () => {
      this.dispatch?.({
        type: 'clear'
      });
    });
    _defineProperty(this, "render", props => {
      // this code assumes a single place of render per instance of NotificationUI
      const [messages, dispatch] = (0, _react().useReducer)(_notificationReducer().notificationReducer, []);
      this.dispatch = dispatch;
      return /*#__PURE__*/_react().default.createElement(_uiFoundationUiNotifications2().NotificationCenter, _extends({}, props, {
        notifications: messages
      }));
    });
    _defineProperty(this, "renderContext", ({
      children
    }) => {
      return /*#__PURE__*/_react().default.createElement(_uiFoundationUiNotifications().NotificationContext.Provider, {
        value: this
      }, children);
    });
    uiRuntimeExtension.registerHudItem( /*#__PURE__*/_react().default.createElement(this.render, {
      key: "NotificationUI"
    }));
    uiRuntimeExtension.registerRenderHooks({
      reactContext: this.renderContext
    });
  }
  /** removes/archives a message from the log */
  dismiss(id) {
    this.dispatch?.({
      type: 'dismiss',
      id
    });
  }
}
exports.default = NotificationUI;
_defineProperty(NotificationUI, "dependencies", [_ui().UIAspect]);
_defineProperty(NotificationUI, "runtime", _ui().UIRuntime);
_notifications().NotificationsAspect.addRuntime(NotificationUI);

//# sourceMappingURL=notification.ui.runtime.js.map